/* Command-line contoll script for Weasel

						Vasilkin Andrey, 2005 y.
*/

call rxfuncadd 'sysloadfuncs', 'rexxutil', 'sysloadfuncs';
call sysloadfuncs

parse arg CmdLine
parse value CmdLine with Action ' ' User ' ' Pswd ' ' CmdLine
Action = translate(Action)

PostList = substr(Action,1,1)='+'
if PostList then Action = substr(Action,2)

if Action \= 'LIST' & Action \= 'NEW' & Action \= 'DEL' then 
do
  EOL = X2C('0D')||X2C('0A')
  H = 'WEASEL-CTRL by Andrey Vasilkin, 2004'||EOL||EOL
  H = H||'Usage: WEASEL-CTRL [option] [param1 param2 ...]'||EOL
  H = H||'options:'||EOL
  H = H||'  LIST - list of users'||EOL
  H = H||'  NEW - add user: WEASEL-CTRL NEW <user> <password> ["name" ["comment"]]'||EOL
  H = H||'  DEL - delete user: WEASEL-CTRL NEW <user>'||EOL
  say H
  exit
end

FCfg = value('ETC',,'OS2ENVIRONMENT')  || "\weasel-ctrl.cfg"
FIni = 'weasel.ini'

/*********************************************/
/*                Read config                */
/*********************************************/

parse SOURCE sCmd sFunc IniPath
CfgLine = LASTPOS('\', IniPath)
if CfgLine > 0 THEN IniPath = LEFT(IniPath, CfgLine-1)

CfgLine = 0
Domain = ''
do while lines(FCfg'.s.') \= 0
  line = strip(linein(FCfg))
  CfgLine = CfgLine+1
  if (line = '') | (substr(line,1,1) = '#') then iterate

  key = translate(word(line,1))
  val = strip(substr(line,length(key)+1))
  if val='' then call CfgError 'key 'key' has no value'

  select
  when key = 'DOMAIN' then Domain = val
  when key = 'WEASELPATH' then IniPath = val
  otherwise
    say 'Unknown key 'key
    exit
  end
end
call stream FCfg,'c','close'

FIni = IniPath'\'FIni

drop IniPath
drop CfgLine
drop FCfg

/*********************************************/
/*                   Main                    */
/*********************************************/

select
when Action = 'LIST' then call ActionList
when Action = 'NEW' then call ActionNew
when Action = 'DEL' then call ActionDel
otherwise
end

if PostList then call ActionList

EXIT


ActionList:
/*********************************************/
/*                Users List                 */
/*********************************************/

  count = 0
  call CheckIniError SysIni(FIni, 'All:', 'Apps.')

  /* --- read ini --- */
  do i = 1 to Apps.0
    if substr(Apps.i,1,1) \='$' then
    do 
      if (Apps.i \= 'postmaster') & (Apps.i \= 'unknown') then
      do
        email.count = Apps.i
/*        Password.count = SysIni(FIni,Apps.i,'Password')*/
        S = SysIni(FIni,Apps.i,'RealName')
        if S = "ERROR:" then S = ""
        Realname.count = S
        S = SysIni(FIni,Apps.i,'Comments')
        if S = "ERROR:" then S = ""
        Comment.count = S
        count = count + 1
      end 
    end
  end

  /* --- sort --- */
  do i = 0 to count-2
    do j = i+1 to count-1
      if RealName.i > RealName.j then
      do
        tempRealName = RealName.j; tempComment = Comment.j; tempEmail = email.j
        RealName.j = RealName.i; Comment.j  = Comment.i; email.j = email.i
        RealName.i = tempRealName; Comment.i = tempComment;  email.i = tempEmail
      end
    end 
  end

  /* --- output --- */
  if Domain\='' then Domain = '@'Domain
  do i = 0 to count-1
    say email.i''Domain' "'Comment.i'" "'RealName.i'"'
  end
return

ActionNew:
/*********************************************/
/*                 New user                  */
/*********************************************/

  if substr(CmdLine,1,1) = '"' then QC = '"'
  else if substr(CmdLine,1,1) = "'" then QC = "'"
  else QC = ''

  if (QC\='') then
  do
    A = pos(QC,substr(CmdLine,2))
    if A = 0 then
    do
      A = length(CmdLine)-1 
      _CmdLine = ''
    end
    else do
      _CmdLine = substr(CmdLine,A+2)
      A = A-1
    end
    RealName = strip(substr(CmdLine,2,A))
  end
  else do
    RealName = subword(CmdLine,1,1)
    _CmdLine = subword(CmdLine,2)
  end

  Comment = strip(strip(strip(_CmdLine),,QC))

  if Pswd='*' then
    Pswd = SysIni(FIni, User, 'Password');

  if \PostList then
  do
    say 'New record:'
    say '  user: 'User
    say '  password: 'Pswd
    say '  real name: 'RealName
    say '  comment: 'Comment
  end;

  rc = SysIni(FIni, User, 'DELETE:')
  rc = SysIni(FIni, User, 'RealName', RealName) 
  if Pswd\='' then
    rc = SysIni(FIni, User, 'Password', Pswd)
  rc = SysIni(FIni, User, 'Comments' , Comment)

  Nul = '00'X
  MailRoot = SysIni(FIni, '$SYS', 'MailRoot')
  j = POS(Nul,MailRoot)
  IF j > 0 THEN MailRoot = LEFT(MailRoot, j-1)
  MailRoot = STRIP(MailRoot)
  MailRoot = TRANSLATE(MailRoot, '\', '/')
  call SysMkDir(MailRoot || User)

/*  call SysMkDir('C:\MPTN\ETC\MAIL\' || User)*/
return

ActionDel:
/*********************************************/
/*                Delete user                */
/*********************************************/

  rc = SysIni(FIni, User, 'DELETE:')
return

CheckIniError:
  if arg(1) \= "ERROR:" then return
  say "Error with "FIni
  exit

CfgError:
  say '"'FCfg'", line 'CfgLine': 'arg(1)
  exit